TanStack

Solid Example: Kitchen Sink

import {
  Show,
  createContext,
  createSignal,
  onCleanup,
  onMount,
  useContext,
} from 'solid-js'
import { Dynamic, render } from 'solid-js/web'
import { TanStackDevtools } from '@tanstack/solid-devtools'
import { hotkeysDevtoolsPlugin } from '@tanstack/solid-hotkeys-devtools'
import {
  HotkeysProvider,
  createHeldKeyCodes,
  createHeldKeys,
  createHotkey,
  createHotkeyHint,
  createHotkeyRecorder,
  createHotkeyRegistrations,
  createHotkeySequence,
  createHotkeySequenceRecorder,
  createHotkeySequences,
  createHotkeys,
  createKeyHold,
  formatForDisplay,
} from '@tanstack/solid-hotkeys'
import type {
  Hotkey,
  HotkeySequence,
  RecorderKeyMode,
  RegisterableHotkey,
} from '@tanstack/solid-hotkeys'
import './styles.css'
import type { JSX } from 'solid-js'

const ActivityContext = createContext<(message: string) => void>(() => {})
const pages = [
  { to: '/', label: 'Tickets', shortcut: 'Alt+[Digit1]' },
  { to: '/editor', label: 'Editor', shortcut: 'Alt+[Digit2]' },
  { to: '/sequences', label: 'Sequences', shortcut: 'Alt+[Digit3]' },
  { to: '/recording', label: 'Recording', shortcut: 'Alt+[Digit4]' },
  { to: '/formatting', label: 'Formatting', shortcut: 'Alt+[Digit5]' },
] as const
/** A separate component lets each navigation link or button subscribe to its hint. */
function Hint(props: { hotkey: RegisterableHotkey; enabled?: boolean }) {
  const visible = createHotkeyHint(() => props.hotkey)
  return (
    <Show when={visible() && props.enabled !== false}>
      <kbd>{formatForDisplay(props.hotkey)}</kbd>
    </Show>
  )
}
/** Global shortcuts remain registered while route components mount and unmount. */
function Layout() {
  const [path, setPath] = createSignal(location.hash.slice(1) || '/')
  onMount(() => {
    const update = () => setPath(location.hash.slice(1) || '/')
    window.addEventListener('hashchange', update)
    onCleanup(() => window.removeEventListener('hashchange', update))
  })
  const [showShortcuts, setShowShortcuts] = createSignal(false)
  const [activity, setActivity] = createSignal<Array<string>>([])
  const log = (message: string) => {
    setActivity((items) => [message, ...items].slice(0, 6))
  }
  const keys = createHeldKeys()
  const codes = createHeldKeyCodes()
  const shift = createKeyHold('Shift')
  const { hotkeys, sequences } = createHotkeyRegistrations()
  const registrations = () => [...hotkeys(), ...sequences()]
  const groups = () => [
    ...new Set(
      registrations().map((reg) => reg.options.meta?.group ?? 'Other'),
    ),
  ]
  createHotkeys(
    pages.map((page) => ({
      hotkey: page.shortcut,
      callback: () => {
        location.hash = page.to
      },
      options: { meta: { name: `Open ${page.label}`, group: 'Navigation' } },
    })),
    () => ({ ignoreInputs: true }),
  )
  createHotkey(
    'Alt+Shift+[KeyK]',
    () => setShowShortcuts((value) => !value),
    () => ({
      meta: { name: 'Show shortcuts', group: 'Navigation' },
    }),
  )
  return (
    <ActivityContext.Provider value={log}>
      <header>
        <h1>TanStack Hotkeys kitchen sink</h1>
        <p>
          Hold Alt / Option to see shortcut hints. Change routes to see
          registrations mount and unmount.
        </p>
        <nav aria-label="Examples">
          {pages.map((page) => (
            <a href={`#${page.to}`} class={path() === page.to ? 'active' : ''}>
              {page.label} <Hint hotkey={page.shortcut} />
            </a>
          ))}
        </nav>
        <button
          onClick={() => setShowShortcuts((value) => !value)}
          aria-expanded={showShortcuts()}
        >
          {showShortcuts() ? 'Hide' : 'Show'} shortcuts{' '}
          <Hint hotkey="Alt+Shift+[KeyK]" />
        </button>
      </header>
      {showShortcuts() && (
        <section aria-label="Registered shortcuts">
          <h2>Registered shortcuts</h2>
          <p>
            Global and current-route registrations, including disabled handlers.
            Scoped shortcuts run inside their target.
          </p>
          {groups().map((group) => (
            <div>
              <h3>{group}</h3>
              <table>
                <thead>
                  <tr>
                    <th>Action</th>
                    <th>Binding</th>
                    <th>Status</th>
                  </tr>
                </thead>
                <tbody>
                  {registrations()
                    .filter(
                      (reg) => (reg.options.meta?.group ?? 'Other') === group,
                    )
                    .map((reg) => (
                      <tr>
                        <td>
                          {reg.options.meta?.name ?? reg.id}
                          <br />
                          <small>{reg.options.meta?.description}</small>
                        </td>
                        <td>
                          {('hotkey' in reg ? [reg.hotkey] : reg.sequence)
                            .map((step) => formatForDisplay(step))
                            .join(' → ')}
                        </td>
                        <td>
                          {reg.options.enabled === false
                            ? 'Disabled'
                            : `${reg.triggerCount} fired`}
                        </td>
                      </tr>
                    ))}
                </tbody>
              </table>
            </div>
          ))}
        </section>
      )}
      <main>
        <Dynamic component={routeComponents[path()] ?? Tickets} />
      </main>
      <section>
        <h2>Key state</h2>
        <p>
          Keys: {keys().join(' + ') || 'None'}
          <br />
          Codes: {Object.values(codes()).join(' + ') || 'None'}
          <br />
          Shift: {shift() ? 'held' : 'released'}
        </p>
        <h2>Activity</h2>
        <button onClick={() => setActivity([])}>Clear log</button>
        <ul aria-live="polite">
          {activity().map((message) => (
            <li>{message}</li>
          ))}
        </ul>
      </section>
      <TanStackDevtools plugins={[hotkeysDevtoolsPlugin()]} />
    </ActivityContext.Provider>
  )
}
/** Single shortcuts share handlers with buttons and respect enabled/input policies. */
function Tickets() {
  const log = useContext(ActivityContext)
  const [count, setCount] = createSignal(0)
  const [enabled, setEnabled] = createSignal(true)
  const create = () => {
    setCount((n) => n + 1)
    log('Ticket created')
  }
  const save = () => log('Pending ticket saved')
  createHotkey('Alt+[KeyC]', create, () => ({
    enabled: enabled(),
    ignoreInputs: false,
    meta: {
      name: 'Create ticket',
      description: 'Also works while entering a ticket note',
      group: 'Tickets',
    },
  }))
  createHotkey('Alt+[KeyS]', save, () => ({
    enabled: enabled(),
    meta: { name: 'Save pending ticket', group: 'Tickets' },
  }))
  return (
    <section>
      <h2>Tickets</h2>
      <p>
        Created: {count()}. Hold Alt / Option for hints. Release and press again
        to create another ticket.
      </p>
      <label>
        <input
          type="checkbox"
          checked={enabled()}
          onChange={(e) => setEnabled(e.currentTarget.checked)}
        />{' '}
        Enable ticket actions
      </label>
      <p>
        <button disabled={!enabled()} onClick={create}>
          Create ticket <Hint hotkey="Alt+[KeyC]" enabled={enabled()} />
        </button>
        <button disabled={!enabled()} onClick={save}>
          Save pending <Hint hotkey="Alt+[KeyS]" enabled={enabled()} />
        </button>
      </p>
      <label>
        Ticket note{' '}
        <input placeholder="Try Alt + the physical C key while typing" />
      </label>
      <p>
        Create uses <code>ignoreInputs: false</code>; Save uses the default
        input filtering. The provider supplies <code>requireReset: true</code>.
      </p>
    </section>
  )
}
/** Each editor owns a target ref, so the same shortcuts can be reused independently. */
function EditorPane({ name }: { name: string }) {
  const log = useContext(ActivityContext)
  let target: HTMLFieldSetElement | undefined
  const [text, setText] = createSignal('One shortcut, two independent editors.')
  const [saves, setSaves] = createSignal(0)
  createHotkeys(
    [
      {
        hotkey: 'Mod+[KeyS]',
        callback: () => {
          setSaves((n) => n + 1)
          log(`${name} saved`)
        },
        options: {
          meta: {
            name: `Save ${name}`,
            group: 'Editor',
            description: 'Scoped to this editor',
          },
        },
      },
      {
        hotkey: 'Alt+[Backspace]',
        callback: () => {
          setText('')
          log(`${name} cleared`)
        },
        options: { meta: { name: `Clear ${name}`, group: 'Editor' } },
      },
    ],
    () => ({ target, ignoreInputs: false }),
  )
  return (
    <fieldset ref={target}>
      <legend>
        {name} — {saves()} saves
      </legend>
      <label>
        Editor content
        <textarea
          rows={3}
          value={text()}
          onChange={(e) => setText(e.currentTarget.value)}
        />
      </label>
      <p>
        <kbd>{formatForDisplay('Mod+[KeyS]')}</kbd> Save;{' '}
        <kbd>{formatForDisplay('Alt+[Backspace]')}</kbd> Clear
      </p>
    </fieldset>
  )
}
/** Exercises target scope, repeat/reset, propagation, and keyup options. */
function Editor() {
  const log = useContext(ActivityContext)
  const [repeat, setRepeat] = createSignal(false)
  const [count, setCount] = createSignal(0)
  const [bubble, setBubble] = createSignal(false)
  createHotkey(
    'Alt+[ArrowRight]',
    () => setCount((n) => n + 1),
    () => ({
      requireReset: !repeat(),
      meta: { name: 'Advance counter', group: 'Editor' },
    }),
  )
  let scope: HTMLFieldSetElement | undefined
  createHotkey(
    'Alt+[KeyB]',
    () => log('Scoped B handler'),
    () => ({
      target: scope,
      stopPropagation: !bubble(),
      preventDefault: !bubble(),
      meta: { name: 'Scoped propagation demo', group: 'Editor' },
    }),
  )
  createHotkey(
    'Alt+[KeyB]',
    () => log('Document B handler received the bubbled event'),
    () => ({ meta: { name: 'Document propagation demo', group: 'Editor' } }),
  )
  createHotkey(
    'Alt+[KeyU]',
    () => log('Key released: keyup handler'),
    () => ({
      eventType: 'keyup',
      meta: { name: 'Run on release', group: 'Editor' },
    }),
  )
  return (
    <section>
      <h2>Editor scopes</h2>
      <p>
        Save is registered in both editors. Focus a textarea to choose which
        handler receives it.
      </p>
      <EditorPane name="Draft" />
      <EditorPane name="Notes" />
      <h3>Repeat and keyup</h3>
      <label>
        <input
          type="checkbox"
          checked={repeat()}
          onChange={(e) => setRepeat(e.currentTarget.checked)}
        />{' '}
        Allow key repeat
      </label>
      <p>
        Hold <kbd>{formatForDisplay('Alt+[ArrowRight]')}</kbd> to advance:{' '}
        {count()}. Release <kbd>{formatForDisplay('Alt+[KeyU]')}</kbd> to log a
        keyup event.
      </p>
      <fieldset ref={scope} tabIndex={0}>
        <legend>Propagation</legend>
        <label>
          <input
            type="checkbox"
            checked={bubble()}
            onChange={(e) => setBubble(e.currentTarget.checked)}
          />{' '}
          Allow bubbling and browser defaults
        </label>
        <p>
          Focus this area and press <kbd>{formatForDisplay('Alt+[KeyB]')}</kbd>.
          Activity shows whether the document handler also receives the event.
        </p>
        <button onClick={() => scope?.focus()}>Focus this area</button>
      </fieldset>
    </section>
  )
}
/** Single and bulk sequences share a timeout and expose progress through the registry. */
function Sequences() {
  const log = useContext(ActivityContext)
  const [timeout, setTimeoutValue] = createSignal(1000)
  createHotkeySequence(
    ['[KeyG]', '[KeyG]'],
    () => log('Sequence: go to top'),
    () => ({
      timeout: timeout(),
      meta: { name: 'Go to top', group: 'Sequences' },
    }),
  )
  createHotkeySequences(
    [
      {
        sequence: ['[KeyG]', '[KeyI]'],
        callback: () => log('Sequence: inbox'),
        options: { meta: { name: 'Open inbox', group: 'Sequences' } },
      },
      {
        sequence: ['Shift+[KeyR]', 'Shift+[KeyT]'],
        callback: () => log('Sequence: shifted chord chain'),
        options: { meta: { name: 'Shifted chain', group: 'Sequences' } },
      },
    ],
    () => ({ timeout: timeout() }),
  )
  const { sequences } = createHotkeyRegistrations()
  return (
    <section>
      <h2>Sequences</h2>
      <p>
        Try the physical G position twice, G then I, or hold Shift and press R
        then T.
      </p>
      <label>
        Time between steps: {timeout()} ms{' '}
        <input
          type="range"
          min="300"
          max="2500"
          step="100"
          value={timeout()}
          onChange={(e) => setTimeoutValue(Number(e.currentTarget.value))}
        />
      </label>
      <table>
        <thead>
          <tr>
            <th>Action</th>
            <th>Sequence</th>
            <th>Progress</th>
          </tr>
        </thead>
        <tbody>
          {sequences().map((reg) => (
            <tr>
              <td>{reg.options.meta?.name}</td>
              <td>
                {reg.sequence.map((step) => formatForDisplay(step)).join(' → ')}
              </td>
              <td>
                {reg.matchedStepCount}/{reg.sequence.length} steps;{' '}
                {reg.triggerCount} fired
              </td>
            </tr>
          ))}
        </tbody>
      </table>
      <p>
        Wrong keys and timeouts reset progress. Modifier-only presses and
        automatic repeats do not advance a sequence.
      </p>
    </section>
  )
}
/** Recorder output feeds local state; reset and validation are application policy. */
function Recording() {
  const log = useContext(ActivityContext)
  const initial: Hotkey = 'Alt+[KeyR]'
  const [hotkey, setHotkey] = createSignal<Hotkey>(initial)
  const [mode, setMode] = createSignal<RecorderKeyMode>('code')
  const [problem, setProblem] = createSignal('')
  const [sequence, setSequence] = createSignal<HotkeySequence>([
    '[KeyX]',
    '[KeyY]',
  ])
  const [sequenceProblem, setSequenceProblem] = createSignal('')
  const [idle, setIdle] = createSignal(false)
  const [commitOnEnter, setCommitOnEnter] = createSignal(true)
  createHotkey(
    hotkey,
    () => log('Your recorded shortcut fired'),
    () => ({
      meta: { name: 'Recorded action', group: 'Recording' },
    }),
  )
  createHotkeySequence(
    sequence,
    () => log('Your recorded sequence fired'),
    () => ({
      meta: { name: 'Recorded sequence', group: 'Recording' },
    }),
  )
  const recorder = createHotkeyRecorder(() => ({
    recordBy: mode(),
    ignoreInputs: false,
    detectConflicts: {
      exclude: (reg) => reg.options.meta?.name === 'Recorded action',
    },
    validate: (_, { parsedHotkey }) =>
      parsedHotkey.modifiers.length > 0 ||
      'Include a modifier for this action.',
    onReject: ({ message }) => setProblem(message),
    onRecord: (value) => {
      setHotkey(value)
      setProblem('')
      log(`Recorded ${value}`)
    },
    onClear: () => {
      setHotkey(initial)
      setProblem('')
      log('Restored default shortcut')
    },
    onCancel: () => setProblem('Recording cancelled. Binding unchanged.'),
  }))
  const sequenceRecorder = createHotkeySequenceRecorder(() => ({
    recordBy: mode(),
    ignoreInputs: false,
    idleTimeoutMs: idle() ? 1500 : undefined,
    commitKeys: commitOnEnter() ? 'enter' : 'none',
    detectConflicts: {
      exclude: (reg) => reg.options.meta?.name === 'Recorded sequence',
    },
    validate: (steps) => steps.length >= 2 || 'Record at least two chords.',
    onRecord: (value) => {
      setSequence(value)
      setSequenceProblem('')
      log(`Recorded sequence ${value.join(' → ')}`)
    },
    onReject: (reason) => setSequenceProblem(reason.message),
    onClear: () => {
      setSequence(['[KeyX]', '[KeyY]'])
      setSequenceProblem('Restored default sequence.')
    },
    onCancel: () => setSequenceProblem('Recording cancelled.'),
  }))
  return (
    <section>
      <h2>Recording</h2>
      <p>
        Recorded bindings go directly into registrations. Changes live in this
        route's local state.
      </p>
      <label>
        Record by{' '}
        <select
          value={mode()}
          disabled={recorder.isRecording() || sequenceRecorder.isRecording()}
          onChange={(e) => setMode(e.currentTarget.value as RecorderKeyMode)}
        >
          <option value="code">Physical code (default)</option>
          <option value="key">Logical character</option>
        </select>
      </label>
      <h3>Single shortcut</h3>
      <p>
        <kbd>{formatForDisplay(hotkey())}</kbd> — stored as{' '}
        <code>{hotkey()}</code>
      </p>
      <button
        disabled={recorder.isRecording() || sequenceRecorder.isRecording()}
        onClick={() => {
          setProblem('')
          recorder.startRecording()
        }}
      >
        {recorder.isRecording() ? 'Listening…' : 'Record shortcut'}
      </button>
      <button
        onClick={() => {
          recorder.stopRecording()
          setHotkey(initial)
          setProblem('')
        }}
      >
        Reset
      </button>
      {recorder.isRecording() && (
        <button onClick={recorder.cancelRecording}>Cancel</button>
      )}
      <p>
        Include a modifier. Try Alt + 1 for a navigation conflict. Escape
        cancels; Backspace restores the initial shortcut.
      </p>
      <p role="status">{problem()}</p>
      <h3>Sequence</h3>
      <p>
        {(sequenceRecorder.isRecording()
          ? sequenceRecorder.steps()
          : sequence()
        )
          .map((step) => formatForDisplay(step))
          .join(' → ') || 'Waiting for the first chord…'}
      </p>
      <label>
        <input
          type="checkbox"
          checked={idle()}
          onChange={(e) => setIdle(e.currentTarget.checked)}
        />{' '}
        Commit after 1.5 seconds idle
      </label>
      <label>
        <input
          type="checkbox"
          checked={commitOnEnter()}
          onChange={(e) => setCommitOnEnter(e.currentTarget.checked)}
        />{' '}
        Enter commits the sequence
      </label>
      <p>
        <button
          disabled={recorder.isRecording() || sequenceRecorder.isRecording()}
          onClick={() => {
            setSequenceProblem('')
            sequenceRecorder.startRecording()
          }}
        >
          Record sequence
        </button>
        <button
          disabled={
            !sequenceRecorder.isRecording() || !sequenceRecorder.steps().length
          }
          onClick={sequenceRecorder.commitRecording}
        >
          Commit
        </button>
        {sequenceRecorder.isRecording() && (
          <button onClick={sequenceRecorder.cancelRecording}>Cancel</button>
        )}
      </p>
      <p>
        Record at least two chords. Backspace removes a step; when empty it
        restores the initial sequence. Rejected steps remain editable.
      </p>
      <p role="status">{sequenceProblem()}</p>
    </section>
  )
}
/** Formatting changes labels, not the binding being registered. */
function Formatting() {
  const [platform, setPlatform] = createSignal<'mac' | 'windows' | 'linux'>(
    'mac',
  )
  const [modifierSymbols, setModifierSymbols] = createSignal(false)
  const [keySymbols, setKeySymbols] = createSignal(true)
  const options = () => ({
    platform: platform(),
    useSymbols: { modifiers: modifierSymbols(), keys: keySymbols() },
  })
  return (
    <section>
      <h2>Formatting</h2>
      <label>
        Platform{' '}
        <select
          value={platform()}
          onChange={(e) =>
            setPlatform(e.currentTarget.value as 'mac' | 'windows' | 'linux')
          }
        >
          <option value="mac">macOS</option>
          <option value="windows">Windows</option>
          <option value="linux">Linux</option>
        </select>
      </label>
      <label>
        <input
          type="checkbox"
          checked={modifierSymbols()}
          onChange={(e) => setModifierSymbols(e.currentTarget.checked)}
        />{' '}
        Modifier symbols
      </label>
      <label>
        <input
          type="checkbox"
          checked={keySymbols()}
          onChange={(e) => setKeySymbols(e.currentTarget.checked)}
        />{' '}
        Key symbols
      </label>
      <table>
        <thead>
          <tr>
            <th>Stored binding</th>
            <th>String</th>
            <th>Parts</th>
          </tr>
        </thead>
        <tbody>
          {(
            [
              'Mod+Shift+ArrowUp',
              'Control++',
              'Alt+[KeyS]',
              'Mod+[NumpadAdd]',
            ] as const
          ).map((hotkey) => (
            <tr>
              <td>
                <code>{hotkey}</code>
              </td>
              <td>{formatForDisplay(hotkey, options())}</td>
              <td>
                {formatForDisplay(hotkey, { ...options(), parts: true }).map(
                  (part) => (
                    <kbd>{part}</kbd>
                  ),
                )}
              </td>
            </tr>
          ))}
        </tbody>
      </table>
      <p>
        Physical codes use readable fallback labels. Supply a resolved{' '}
        <code>layoutMap</code> or explicit <code>keyLabels</code> for
        layout-specific labels.
      </p>
    </section>
  )
}
// A changed route mounts a new component, so its registrations clean up naturally.
const routeComponents: Record<string, () => JSX.Element> = {
  '/': Tickets,
  '/editor': Editor,
  '/sequences': Sequences,
  '/recording': Recording,
  '/formatting': Formatting,
}
const dispose = render(
  () => (
    <HotkeysProvider defaultOptions={{ hotkey: { requireReset: true } }}>
      <Layout />
    </HotkeysProvider>
  ),
  document.getElementById('root')!,
)
import.meta.hot?.dispose(dispose)

TanStack

Angular Example: Kitchen Sink

import {
  Component,
  DestroyRef,
  Injectable,
  computed,
  inject,
  input,
  signal,
  viewChild,
} from '@angular/core'
import {
  formatForDisplay,
  injectHeldKeyCodes,
  injectHeldKeys,
  injectHotkey,
  injectHotkeyHint,
  injectHotkeyRecorder,
  injectHotkeyRegistrations,
  injectHotkeySequence,
  injectHotkeySequenceRecorder,
  injectHotkeySequences,
  injectHotkeys,
  injectKeyHold,
} from '@tanstack/angular-hotkeys'
import type { ElementRef } from '@angular/core'
import type {
  Hotkey,
  HotkeySequence,
  RecorderKeyMode,
} from '@tanstack/angular-hotkeys'

@Injectable({ providedIn: 'root' })
export class Activity {
  readonly messages = signal<Array<string>>([])
  log(message: string) {
    this.messages.update((items) => [message, ...items].slice(0, 6))
  }
}

@Component({
  selector: 'shortcut-hint',
  standalone: true,
  template: `@if (visible() && enabled()) {
    <kbd>{{ format(hotkey()) }}</kbd>
  }`,
})
export class Hint {
  readonly hotkey = input<Hotkey>('Escape')
  readonly enabled = input(true)
  readonly visible = injectHotkeyHint(() => this.hotkey())
  readonly format = formatForDisplay
}

@Component({
  selector: 'ticket-demo',
  standalone: true,
  imports: [Hint],
  template: ` <section>
    <h2>Tickets</h2>
    <p>Created: {{ count() }}. Buttons and shortcuts share handlers.</p>
    <label
      ><input
        #toggle
        type="checkbox"
        [checked]="enabled()"
        (change)="enabled.set(toggle.checked)"
      />
      Enable ticket actions</label
    >
    <button [disabled]="!enabled()" (click)="create()">
      Create ticket <shortcut-hint hotkey="Alt+[KeyC]" [enabled]="enabled()" />
    </button>
    <button [disabled]="!enabled()" (click)="save()">
      Save pending <shortcut-hint hotkey="Alt+[KeyS]" [enabled]="enabled()" />
    </button>
    <label>Ticket note <input placeholder="Try Alt + C while typing" /></label>
    <p>
      Create uses ignoreInputs: false; Save uses default filtering. Release
      before firing again.
    </p>
  </section>`,
})
export class Tickets {
  readonly activity = inject(Activity)
  readonly count = signal(0)
  readonly enabled = signal(true)
  create = () => {
    this.count.update((n) => n + 1)
    this.activity.log('Ticket created')
  }
  save = () => this.activity.log('Ticket saved')
  constructor() {
    injectHotkey('Alt+[KeyC]', this.create, () => ({
      enabled: this.enabled(),
      ignoreInputs: false,
      meta: { name: 'Create ticket', group: 'Tickets' },
    }))
    injectHotkey('Alt+[KeyS]', this.save, () => ({
      enabled: this.enabled(),
      meta: { name: 'Save ticket', group: 'Tickets' },
    }))
  }
}

@Component({
  selector: 'editor-pane',
  standalone: true,
  template: ` <fieldset #target>
    <legend>{{ name() }} — {{ saves() }} saves</legend>
    <label
      >Editor content<textarea
        #content
        rows="3"
        [value]="text()"
        (input)="text.set(content.value)"
      ></textarea>
    </label>
    <p>
      <kbd>{{ format('Mod+[KeyS]') }}</kbd> Save;
      <kbd>{{ format('Alt+[Backspace]') }}</kbd> Clear
    </p>
  </fieldset>`,
})
export class EditorPane {
  readonly name = input('Editor')
  readonly target = viewChild<ElementRef<HTMLElement>>('target')
  readonly text = signal('One shortcut, two independent editors.')
  readonly saves = signal(0)
  readonly activity = inject(Activity)
  readonly format = formatForDisplay
  constructor() {
    injectHotkeys(
      () => [
        {
          hotkey: 'Mod+[KeyS]',
          callback: () => {
            this.saves.update((n) => n + 1)
            this.activity.log(`${this.name()} saved`)
          },
          options: { meta: { name: `Save ${this.name()}`, group: 'Editor' } },
        },
        {
          hotkey: 'Alt+[Backspace]',
          callback: () => this.text.set(''),
          options: { meta: { name: `Clear ${this.name()}`, group: 'Editor' } },
        },
      ],
      () => ({ target: this.target()?.nativeElement, ignoreInputs: false }),
    )
  }
}

@Component({
  selector: 'editor-demo',
  standalone: true,
  imports: [EditorPane],
  template: ` <section>
    <h2>Editor scopes</h2>
    <p>Focus an editor to choose its Save handler.</p>
    <editor-pane name="Draft" /><editor-pane name="Notes" />
    <label
      ><input
        #repeatToggle
        type="checkbox"
        [checked]="repeat()"
        (change)="repeat.set(repeatToggle.checked)"
      />
      Allow repeat</label
    >
    <p>
      Hold Alt + ArrowRight: {{ count() }}. Release Alt + U for a keyup event.
    </p>
    <fieldset #scope tabindex="0">
      <legend>Propagation</legend>
      <label
        ><input
          #bubbleToggle
          type="checkbox"
          [checked]="bubble()"
          (change)="bubble.set(bubbleToggle.checked)"
        />
        Allow bubbling and browser defaults</label
      >
      <p>Focus here and press Alt + B; watch Activity.</p>
      <button (click)="scope.focus()">Focus this area</button>
    </fieldset>
  </section>`,
})
export class Editor {
  readonly repeat = signal(false)
  readonly count = signal(0)
  readonly bubble = signal(false)
  readonly scope = viewChild<ElementRef<HTMLElement>>('scope')
  readonly activity = inject(Activity)
  constructor() {
    injectHotkey(
      'Alt+[ArrowRight]',
      () => this.count.update((n) => n + 1),
      () => ({
        requireReset: !this.repeat(),
        meta: { name: 'Counter', group: 'Editor' },
      }),
    )
    injectHotkey(
      'Alt+[KeyB]',
      () => this.activity.log('Scoped B'),
      () => ({
        target: this.scope()?.nativeElement,
        stopPropagation: !this.bubble(),
        preventDefault: !this.bubble(),
        meta: { name: 'Scoped propagation', group: 'Editor' },
      }),
    )
    injectHotkey('Alt+[KeyB]', () => this.activity.log('Document B'), {
      meta: { name: 'Document propagation', group: 'Editor' },
    })
    injectHotkey('Alt+[KeyU]', () => this.activity.log('Keyup U'), {
      eventType: 'keyup',
      meta: { name: 'Keyup', group: 'Editor' },
    })
  }
}

@Component({
  selector: 'sequence-demo',
  standalone: true,
  template: ` <section>
    <h2>Sequences</h2>
    <p>
      Physical G then G, G then I, or Shift + R then Shift + T. Repeats do not
      advance steps.
    </p>
    <label
      >Timeout: {{ timeout() }} ms
      <input
        #time
        type="range"
        min="300"
        max="2500"
        step="100"
        [value]="timeout()"
        (input)="timeout.set(+time.value)"
    /></label>
    <table>
      <tbody>
        @for (reg of registry.sequences(); track reg.id) {
          <tr>
            <td>{{ reg.options.meta?.name }}</td>
            <td>{{ label(reg.sequence) }}</td>
            <td>
              {{ reg.matchedStepCount }}/{{ reg.sequence.length }} steps;
              {{ reg.triggerCount }} fired
            </td>
          </tr>
        }
      </tbody>
    </table>
  </section>`,
})
export class Sequences {
  readonly timeout = signal(1000)
  readonly activity = inject(Activity)
  readonly registry = injectHotkeyRegistrations()
  label = (sequence: HotkeySequence) =>
    sequence.map((h) => formatForDisplay(h)).join(' → ')
  constructor() {
    injectHotkeySequence(
      ['[KeyG]', '[KeyG]'],
      () => this.activity.log('Go to top'),
      () => ({
        timeout: this.timeout(),
        meta: { name: 'Go to top', group: 'Sequences' },
      }),
    )
    injectHotkeySequences(
      [
        {
          sequence: ['[KeyG]', '[KeyI]'],
          callback: () => this.activity.log('Inbox'),
          options: { meta: { name: 'Inbox', group: 'Sequences' } },
        },
        {
          sequence: ['Shift+[KeyR]', 'Shift+[KeyT]'],
          callback: () => this.activity.log('Shift chain'),
          options: { meta: { name: 'Shift chain', group: 'Sequences' } },
        },
      ],
      () => ({ timeout: this.timeout() }),
    )
  }
}

@Component({
  selector: 'recording-demo',
  standalone: true,
  template: ` <section>
    <h2>Recording</h2>
    <p>Bindings live in route state. Try Alt + 1 for a conflict.</p>
    <label
      >Record by
      <select
        #modeInput
        [value]="mode()"
        [disabled]="recorder.isRecording() || seq.isRecording()"
        (change)="setMode(modeInput.value)"
      >
        <option value="code">Physical code</option>
        <option value="key">Logical key</option>
      </select></label
    >
    <h3>Single shortcut</h3>
    <p>
      <kbd>{{ format(hotkey()) }}</kbd> — <code>{{ hotkey() }}</code>
    </p>
    <button
      [disabled]="recorder.isRecording() || seq.isRecording()"
      (click)="recorder.startRecording()"
    >
      Record shortcut</button
    ><button (click)="recorder.stopRecording(); hotkey.set(initial)">
      Reset
    </button>
    @if (recorder.isRecording()) {
      <button (click)="recorder.cancelRecording()">Cancel</button>
    }
    <h3>Sequence</h3>
    <p>{{ label(seq.isRecording() ? seq.steps() : sequence()) }}</p>
    <label
      ><input
        #idleInput
        type="checkbox"
        [checked]="idle()"
        (change)="idle.set(idleInput.checked)"
      />
      Commit after 1.5 seconds idle</label
    ><label
      ><input
        #enterInput
        type="checkbox"
        [checked]="enter()"
        (change)="enter.set(enterInput.checked)"
      />
      Enter commits</label
    >
    <button
      [disabled]="recorder.isRecording() || seq.isRecording()"
      (click)="seq.startRecording()"
    >
      Record sequence</button
    ><button
      [disabled]="!seq.isRecording() || !seq.steps().length"
      (click)="seq.commitRecording()"
    >
      Commit
    </button>
    @if (seq.isRecording()) {
      <button (click)="seq.cancelRecording()">Cancel</button>
    }
    <p>
      Backspace removes a step or restores the initial binding when empty.
      Rejected steps remain editable.
    </p>
    <p role="status">{{ problem() }}</p>
  </section>`,
})
export class Recording {
  readonly initial: Hotkey = 'Alt+[KeyR]'
  readonly hotkey = signal<Hotkey>(this.initial)
  readonly sequence = signal<HotkeySequence>(['[KeyX]', '[KeyY]'])
  readonly mode = signal<RecorderKeyMode>('code')
  readonly problem = signal('')
  readonly idle = signal(false)
  readonly enter = signal(true)
  readonly activity = inject(Activity)
  readonly format = formatForDisplay
  label = (sequence: HotkeySequence) =>
    sequence.map((h) => formatForDisplay(h)).join(' → ')
  setMode(value: string) {
    this.mode.set(value === 'key' ? 'key' : 'code')
  }
  readonly recorder = injectHotkeyRecorder(() => ({
    recordBy: this.mode(),
    ignoreInputs: false,
    detectConflicts: {
      exclude: (reg) => reg.options.meta?.name === 'Recorded action',
    },
    validate: (_, { parsedHotkey }) =>
      parsedHotkey.modifiers.length > 0 || 'Include a modifier.',
    onRecord: (value) => {
      this.hotkey.set(value)
      this.problem.set('')
    },
    onClear: () => this.hotkey.set(this.initial),
    onReject: (r) => this.problem.set(r.message),
    onCancel: () => this.problem.set('Cancelled'),
  }))
  readonly seq = injectHotkeySequenceRecorder(() => ({
    recordBy: this.mode(),
    ignoreInputs: false,
    idleTimeoutMs: this.idle() ? 1500 : undefined,
    commitKeys: this.enter() ? 'enter' : 'none',
    detectConflicts: {
      exclude: (reg) => reg.options.meta?.name === 'Recorded sequence',
    },
    validate: (steps) => steps.length >= 2 || 'Record at least two chords.',
    onRecord: (value) => {
      this.sequence.set(value)
      this.problem.set('')
    },
    onClear: () => this.sequence.set(['[KeyX]', '[KeyY]']),
    onReject: (r) => this.problem.set(r.message),
    onCancel: () => this.problem.set('Cancelled'),
  }))
  constructor() {
    injectHotkey(
      this.hotkey,
      () => this.activity.log('Recorded shortcut fired'),
      { meta: { name: 'Recorded action', group: 'Recording' } },
    )
    injectHotkeySequence(
      this.sequence,
      () => this.activity.log('Recorded sequence fired'),
      { meta: { name: 'Recorded sequence', group: 'Recording' } },
    )
  }
}

@Component({
  selector: 'format-demo',
  standalone: true,
  template: ` <section>
    <h2>Formatting</h2>
    <label
      >Platform
      <select
        #platformInput
        [value]="platform()"
        (change)="setPlatform(platformInput.value)"
      >
        <option value="mac">macOS</option>
        <option value="windows">Windows</option>
        <option value="linux">Linux</option>
      </select></label
    >
    <label
      ><input
        #mods
        type="checkbox"
        [checked]="modifiers()"
        (change)="modifiers.set(mods.checked)"
      />
      Modifier symbols</label
    ><label
      ><input
        #keyInput
        type="checkbox"
        [checked]="keys()"
        (change)="keys.set(keyInput.checked)"
      />
      Key symbols</label
    >
    <table>
      <thead>
        <tr>
          <th>Binding</th>
          <th>String</th>
          <th>Parts</th>
        </tr>
      </thead>
      <tbody>
        @for (binding of bindings; track binding) {
          <tr>
            <td>
              <code>{{ binding }}</code>
            </td>
            <td>{{ format(binding, options()) }}</td>
            <td>
              @for (part of parts(binding); track $index) {
                <kbd>{{ part }}</kbd>
              }
            </td>
          </tr>
        }
      </tbody>
    </table>
    <p>
      Supply layoutMap or keyLabels for layout labels. Formatting never changes
      binding identity.
    </p>
  </section>`,
})
export class Formatting {
  readonly platform = signal<'mac' | 'windows' | 'linux'>('mac')
  readonly modifiers = signal(false)
  readonly keys = signal(true)
  readonly options = computed(() => ({
    platform: this.platform(),
    useSymbols: { modifiers: this.modifiers(), keys: this.keys() },
  }))
  readonly bindings = [
    'Mod+Shift+ArrowUp',
    'Control++',
    'Alt+[KeyS]',
    'Mod+[NumpadAdd]',
  ] as const
  readonly format = formatForDisplay
  parts = (binding: Hotkey) =>
    formatForDisplay(binding, { ...this.options(), parts: true })
  setPlatform(value: string) {
    this.platform.set(value === 'mac' || value === 'linux' ? value : 'windows')
  }
}

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [Hint, Tickets, Editor, Sequences, Recording, Formatting],
  template: ` <header>
      <h1>TanStack Hotkeys kitchen sink</h1>
      <p>
        Hold Alt / Option for hints. Route changes mount and unmount
        registrations.
      </p>
      <nav>
        @for (page of pages; track page.path) {
          <a [href]="'#' + page.path" [class.active]="path() === page.path"
            >{{ page.name }} <shortcut-hint [hotkey]="page.hotkey"
          /></a>
        }
      </nav>
      <button (click)="show.set(!show())">
        {{ show() ? 'Hide' : 'Show' }} shortcuts
      </button>
    </header>
    @if (show()) {
      <section>
        <h2>Live registry</h2>
        <table>
          <thead>
            <tr>
              <th>Group / action</th>
              <th>Binding</th>
              <th>Status</th>
            </tr>
          </thead>
          <tbody>
            @for (reg of registrations(); track reg.id) {
              <tr>
                <td>
                  {{ reg.options.meta?.group }} / {{ reg.options.meta?.name }}
                </td>
                <td>{{ bindingLabel(reg) }}</td>
                <td>
                  {{
                    reg.options.enabled === false
                      ? 'Disabled'
                      : reg.triggerCount + ' fired'
                  }}
                </td>
              </tr>
            }
          </tbody>
        </table>
      </section>
    }
    <main>
      @switch (path()) {
        @case ('/editor') {
          <editor-demo />
        }
        @case ('/sequences') {
          <sequence-demo />
        }
        @case ('/recording') {
          <recording-demo />
        }
        @case ('/formatting') {
          <format-demo />
        }
        @default {
          <ticket-demo />
        }
      }
    </main>
    <section>
      <h2>Key state</h2>
      <p>
        Keys: {{ keys().join(' + ') || 'None' }}<br />Codes: {{ codeLabel()
        }}<br />Shift: {{ shift() ? 'held' : 'released' }}
      </p>
      <h2>Activity</h2>
      <button (click)="activity.messages.set([])">Clear log</button>
      <ul aria-live="polite">
        @for (message of activity.messages(); track $index) {
          <li>{{ message }}</li>
        }
      </ul>
    </section>`,
})
export class AppComponent {
  readonly pages = [
    { path: '/', name: 'Tickets', hotkey: 'Alt+[Digit1]' },
    { path: '/editor', name: 'Editor', hotkey: 'Alt+[Digit2]' },
    { path: '/sequences', name: 'Sequences', hotkey: 'Alt+[Digit3]' },
    { path: '/recording', name: 'Recording', hotkey: 'Alt+[Digit4]' },
    { path: '/formatting', name: 'Formatting', hotkey: 'Alt+[Digit5]' },
  ] as const
  readonly path = signal(location.hash.slice(1) || '/')
  readonly show = signal(false)
  readonly activity = inject(Activity)
  readonly keys = injectHeldKeys()
  readonly codes = injectHeldKeyCodes()
  readonly shift = injectKeyHold('Shift')
  readonly codeLabel = computed(
    () => Object.values(this.codes()).join(' + ') || 'None',
  )
  readonly registry = injectHotkeyRegistrations()
  readonly registrations = computed(() => [
    ...this.registry.hotkeys(),
    ...this.registry.sequences(),
  ])
  bindingLabel = (reg: ReturnType<typeof this.registrations>[number]) =>
    ('hotkey' in reg ? [reg.hotkey] : reg.sequence)
      .map((h) => formatForDisplay(h))
      .join(' → ')
  constructor() {
    const update = () => this.path.set(location.hash.slice(1) || '/')
    window.addEventListener('hashchange', update)
    inject(DestroyRef).onDestroy(() =>
      window.removeEventListener('hashchange', update),
    )
    injectHotkeys(
      this.pages.map((page) => ({
        hotkey: page.hotkey,
        callback: () => {
          location.hash = page.path
        },
        options: { meta: { name: page.name, group: 'Navigation' } },
      })),
      { ignoreInputs: true },
    )
    injectHotkey(
      'Alt+Shift+[KeyK]',
      () => this.show.update((value) => !value),
      { meta: { name: 'Show shortcuts', group: 'Navigation' } },
    )
  }
}

TanStack

React Example: Kitchen Sink

import { createContext, useCallback, useContext, useRef, useState } from 'react'
import { createRoot } from 'react-dom/client'
import {
  Link,
  Outlet,
  RouterProvider,
  createRootRoute,
  createRoute,
  createRouter,
  useNavigate,
} from '@tanstack/react-router'
import { TanStackDevtools } from '@tanstack/react-devtools'
import { hotkeysDevtoolsPlugin } from '@tanstack/react-hotkeys-devtools'
import {
  HotkeysProvider,
  formatForDisplay,
  useHeldKeyCodes,
  useHeldKeys,
  useHotkey,
  useHotkeyHint,
  useHotkeyRecorder,
  useHotkeyRegistrations,
  useHotkeySequence,
  useHotkeySequenceRecorder,
  useHotkeySequences,
  useHotkeys,
  useKeyHold,
} from '@tanstack/react-hotkeys'
import type {
  Hotkey,
  HotkeySequence,
  RecorderKeyMode,
  RegisterableHotkey,
} from '@tanstack/react-hotkeys'
import './styles.css'

const ActivityContext = createContext<(message: string) => void>(() => {})
const pages = [
  { to: '/', label: 'Tickets', shortcut: 'Alt+[Digit1]' },
  { to: '/editor', label: 'Editor', shortcut: 'Alt+[Digit2]' },
  { to: '/sequences', label: 'Sequences', shortcut: 'Alt+[Digit3]' },
  { to: '/recording', label: 'Recording', shortcut: 'Alt+[Digit4]' },
  { to: '/formatting', label: 'Formatting', shortcut: 'Alt+[Digit5]' },
] as const

/** A separate component lets each navigation link or button subscribe to its hint. */
function Hint({
  hotkey,
  enabled = true,
}: {
  hotkey: RegisterableHotkey
  enabled?: boolean
}) {
  const visible = useHotkeyHint(hotkey)
  return visible && enabled ? <kbd>{formatForDisplay(hotkey)}</kbd> : null
}

/** Global shortcuts remain registered while route components mount and unmount. */
function Layout() {
  const navigate = useNavigate()
  const [showShortcuts, setShowShortcuts] = useState(false)
  const [activity, setActivity] = useState<Array<string>>([])
  const log = useCallback((message: string) => {
    setActivity((items) => [message, ...items].slice(0, 6))
  }, [])
  const keys = useHeldKeys()
  const codes = useHeldKeyCodes()
  const shift = useKeyHold('Shift')
  const { hotkeys, sequences } = useHotkeyRegistrations()
  const registrations = [...hotkeys, ...sequences]
  const groups = [
    ...new Set(registrations.map((reg) => reg.options.meta?.group ?? 'Other')),
  ]

  useHotkeys(
    pages.map((page) => ({
      hotkey: page.shortcut,
      callback: () => {
        void navigate({ to: page.to })
      },
      options: { meta: { name: `Open ${page.label}`, group: 'Navigation' } },
    })),
    { ignoreInputs: true },
  )
  useHotkey('Alt+Shift+[KeyK]', () => setShowShortcuts((value) => !value), {
    meta: { name: 'Show shortcuts', group: 'Navigation' },
  })

  return (
    <ActivityContext.Provider value={log}>
      <header>
        <h1>TanStack Hotkeys kitchen sink</h1>
        <p>
          Hold Alt / Option to see shortcut hints. Change routes to see
          registrations mount and unmount.
        </p>
        <nav aria-label="Examples">
          {pages.map((page) => (
            <Link
              key={page.to}
              to={page.to}
              activeOptions={{ exact: true }}
              activeProps={{ className: 'active' }}
            >
              {page.label} <Hint hotkey={page.shortcut} />
            </Link>
          ))}
        </nav>
        <button
          onClick={() => setShowShortcuts((value) => !value)}
          aria-expanded={showShortcuts}
        >
          {showShortcuts ? 'Hide' : 'Show'} shortcuts{' '}
          <Hint hotkey="Alt+Shift+[KeyK]" />
        </button>
      </header>
      {showShortcuts && (
        <section aria-label="Registered shortcuts">
          <h2>Registered shortcuts</h2>
          <p>
            Global and current-route registrations, including disabled handlers.
            Scoped shortcuts run inside their target.
          </p>
          {groups.map((group) => (
            <div key={group}>
              <h3>{group}</h3>
              <table>
                <thead>
                  <tr>
                    <th>Action</th>
                    <th>Binding</th>
                    <th>Status</th>
                  </tr>
                </thead>
                <tbody>
                  {registrations
                    .filter(
                      (reg) => (reg.options.meta?.group ?? 'Other') === group,
                    )
                    .map((reg) => (
                      <tr key={reg.id}>
                        <td>
                          {reg.options.meta?.name ?? reg.id}
                          <br />
                          <small>{reg.options.meta?.description}</small>
                        </td>
                        <td>
                          {('hotkey' in reg ? [reg.hotkey] : reg.sequence)
                            .map((step) => formatForDisplay(step))
                            .join(' → ')}
                        </td>
                        <td>
                          {reg.options.enabled === false
                            ? 'Disabled'
                            : `${reg.triggerCount} fired`}
                        </td>
                      </tr>
                    ))}
                </tbody>
              </table>
            </div>
          ))}
        </section>
      )}
      <main>
        <Outlet />
      </main>
      <section>
        <h2>Key state</h2>
        <p>
          Keys: {keys.join(' + ') || 'None'}
          <br />
          Codes: {Object.values(codes).join(' + ') || 'None'}
          <br />
          Shift: {shift ? 'held' : 'released'}
        </p>
        <h2>Activity</h2>
        <button onClick={() => setActivity([])}>Clear log</button>
        <ul aria-live="polite">
          {activity.map((message, i) => (
            <li key={i}>{message}</li>
          ))}
        </ul>
      </section>
      <TanStackDevtools plugins={[hotkeysDevtoolsPlugin()]} />
    </ActivityContext.Provider>
  )
}

/** Single shortcuts share handlers with buttons and respect enabled/input policies. */
function Tickets() {
  const log = useContext(ActivityContext)
  const [count, setCount] = useState(0)
  const [enabled, setEnabled] = useState(true)
  const create = () => {
    setCount((n) => n + 1)
    log('Ticket created')
  }
  const save = () => log('Pending ticket saved')
  useHotkey('Alt+[KeyC]', create, {
    enabled,
    ignoreInputs: false,
    meta: {
      name: 'Create ticket',
      description: 'Also works while entering a ticket note',
      group: 'Tickets',
    },
  })
  useHotkey('Alt+[KeyS]', save, {
    enabled,
    meta: { name: 'Save pending ticket', group: 'Tickets' },
  })
  return (
    <section>
      <h2>Tickets</h2>
      <p>
        Created: {count}. Hold Alt / Option for hints. Release and press again
        to create another ticket.
      </p>
      <label>
        <input
          type="checkbox"
          checked={enabled}
          onChange={(e) => setEnabled(e.target.checked)}
        />{' '}
        Enable ticket actions
      </label>
      <p>
        <button disabled={!enabled} onClick={create}>
          Create ticket <Hint hotkey="Alt+[KeyC]" enabled={enabled} />
        </button>
        <button disabled={!enabled} onClick={save}>
          Save pending <Hint hotkey="Alt+[KeyS]" enabled={enabled} />
        </button>
      </p>
      <label>
        Ticket note{' '}
        <input placeholder="Try Alt + the physical C key while typing" />
      </label>
      <p>
        Create uses <code>ignoreInputs: false</code>; Save uses the default
        input filtering. The provider supplies <code>requireReset: true</code>.
      </p>
    </section>
  )
}

/** Each editor owns a target ref, so the same shortcuts can be reused independently. */
function EditorPane({ name }: { name: string }) {
  const log = useContext(ActivityContext)
  const target = useRef<HTMLFieldSetElement>(null)
  const [text, setText] = useState('One shortcut, two independent editors.')
  const [saves, setSaves] = useState(0)
  useHotkeys(
    [
      {
        hotkey: 'Mod+[KeyS]',
        callback: () => {
          setSaves((n) => n + 1)
          log(`${name} saved`)
        },
        options: {
          meta: {
            name: `Save ${name}`,
            group: 'Editor',
            description: 'Scoped to this editor',
          },
        },
      },
      {
        hotkey: 'Alt+[Backspace]',
        callback: () => {
          setText('')
          log(`${name} cleared`)
        },
        options: { meta: { name: `Clear ${name}`, group: 'Editor' } },
      },
    ],
    { target, ignoreInputs: false },
  )
  return (
    <fieldset ref={target}>
      <legend>
        {name} — {saves} saves
      </legend>
      <label>
        Editor content
        <textarea
          rows={3}
          value={text}
          onChange={(e) => setText(e.target.value)}
        />
      </label>
      <p>
        <kbd>{formatForDisplay('Mod+[KeyS]')}</kbd> Save;{' '}
        <kbd>{formatForDisplay('Alt+[Backspace]')}</kbd> Clear
      </p>
    </fieldset>
  )
}

/** Exercises target scope, repeat/reset, propagation, and keyup options. */
function Editor() {
  const log = useContext(ActivityContext)
  const [repeat, setRepeat] = useState(false)
  const [count, setCount] = useState(0)
  const [bubble, setBubble] = useState(false)
  useHotkey('Alt+[ArrowRight]', () => setCount((n) => n + 1), {
    requireReset: !repeat,
    meta: { name: 'Advance counter', group: 'Editor' },
  })
  const scope = useRef<HTMLFieldSetElement>(null)
  useHotkey('Alt+[KeyB]', () => log('Scoped B handler'), {
    target: scope,
    stopPropagation: !bubble,
    preventDefault: !bubble,
    meta: { name: 'Scoped propagation demo', group: 'Editor' },
  })
  useHotkey(
    'Alt+[KeyB]',
    () => log('Document B handler received the bubbled event'),
    { meta: { name: 'Document propagation demo', group: 'Editor' } },
  )
  useHotkey('Alt+[KeyU]', () => log('Key released: keyup handler'), {
    eventType: 'keyup',
    meta: { name: 'Run on release', group: 'Editor' },
  })
  return (
    <section>
      <h2>Editor scopes</h2>
      <p>
        Save is registered in both editors. Focus a textarea to choose which
        handler receives it.
      </p>
      <EditorPane name="Draft" />
      <EditorPane name="Notes" />
      <h3>Repeat and keyup</h3>
      <label>
        <input
          type="checkbox"
          checked={repeat}
          onChange={(e) => setRepeat(e.target.checked)}
        />{' '}
        Allow key repeat
      </label>
      <p>
        Hold <kbd>{formatForDisplay('Alt+[ArrowRight]')}</kbd> to advance:{' '}
        {count}. Release <kbd>{formatForDisplay('Alt+[KeyU]')}</kbd> to log a
        keyup event.
      </p>
      <fieldset ref={scope} tabIndex={0}>
        <legend>Propagation</legend>
        <label>
          <input
            type="checkbox"
            checked={bubble}
            onChange={(e) => setBubble(e.target.checked)}
          />{' '}
          Allow bubbling and browser defaults
        </label>
        <p>
          Focus this area and press <kbd>{formatForDisplay('Alt+[KeyB]')}</kbd>.
          Activity shows whether the document handler also receives the event.
        </p>
        <button onClick={() => scope.current?.focus()}>Focus this area</button>
      </fieldset>
    </section>
  )
}

/** Single and bulk sequences share a timeout and expose progress through the registry. */
function Sequences() {
  const log = useContext(ActivityContext)
  const [timeout, setTimeoutValue] = useState(1000)
  useHotkeySequence(['[KeyG]', '[KeyG]'], () => log('Sequence: go to top'), {
    timeout,
    meta: { name: 'Go to top', group: 'Sequences' },
  })
  useHotkeySequences(
    [
      {
        sequence: ['[KeyG]', '[KeyI]'],
        callback: () => log('Sequence: inbox'),
        options: { meta: { name: 'Open inbox', group: 'Sequences' } },
      },
      {
        sequence: ['Shift+[KeyR]', 'Shift+[KeyT]'],
        callback: () => log('Sequence: shifted chord chain'),
        options: { meta: { name: 'Shifted chain', group: 'Sequences' } },
      },
    ],
    { timeout },
  )
  const { sequences } = useHotkeyRegistrations()
  return (
    <section>
      <h2>Sequences</h2>
      <p>
        Try the physical G position twice, G then I, or hold Shift and press R
        then T.
      </p>
      <label>
        Time between steps: {timeout} ms{' '}
        <input
          type="range"
          min="300"
          max="2500"
          step="100"
          value={timeout}
          onChange={(e) => setTimeoutValue(Number(e.target.value))}
        />
      </label>
      <table>
        <thead>
          <tr>
            <th>Action</th>
            <th>Sequence</th>
            <th>Progress</th>
          </tr>
        </thead>
        <tbody>
          {sequences.map((reg) => (
            <tr key={reg.id}>
              <td>{reg.options.meta?.name}</td>
              <td>
                {reg.sequence.map((step) => formatForDisplay(step)).join(' → ')}
              </td>
              <td>
                {reg.matchedStepCount}/{reg.sequence.length} steps;{' '}
                {reg.triggerCount} fired
              </td>
            </tr>
          ))}
        </tbody>
      </table>
      <p>
        Wrong keys and timeouts reset progress. Modifier-only presses and
        automatic repeats do not advance a sequence.
      </p>
    </section>
  )
}

/** Recorder output feeds normal React state; reset and validation are application policy. */
function Recording() {
  const log = useContext(ActivityContext)
  const initial: Hotkey = 'Alt+[KeyR]'
  const [hotkey, setHotkey] = useState<Hotkey>(initial)
  const [mode, setMode] = useState<RecorderKeyMode>('code')
  const [problem, setProblem] = useState('')
  const [sequence, setSequence] = useState<HotkeySequence>(['[KeyX]', '[KeyY]'])
  const [sequenceProblem, setSequenceProblem] = useState('')
  const [idle, setIdle] = useState(false)
  const [commitOnEnter, setCommitOnEnter] = useState(true)
  useHotkey(hotkey, () => log('Your recorded shortcut fired'), {
    meta: { name: 'Recorded action', group: 'Recording' },
  })
  useHotkeySequence(sequence, () => log('Your recorded sequence fired'), {
    meta: { name: 'Recorded sequence', group: 'Recording' },
  })
  const recorder = useHotkeyRecorder({
    recordBy: mode,
    ignoreInputs: false,
    detectConflicts: {
      exclude: (reg) => reg.options.meta?.name === 'Recorded action',
    },
    validate: (_, { parsedHotkey }) =>
      parsedHotkey.modifiers.length > 0 ||
      'Include a modifier for this action.',
    onReject: ({ message }) => setProblem(message),
    onRecord: (value) => {
      setHotkey(value)
      setProblem('')
      log(`Recorded ${value}`)
    },
    onClear: () => {
      setHotkey(initial)
      setProblem('')
      log('Restored default shortcut')
    },
    onCancel: () => setProblem('Recording cancelled. Binding unchanged.'),
  })
  const sequenceRecorder = useHotkeySequenceRecorder({
    recordBy: mode,
    ignoreInputs: false,
    idleTimeoutMs: idle ? 1500 : undefined,
    commitKeys: commitOnEnter ? 'enter' : 'none',
    detectConflicts: {
      exclude: (reg) => reg.options.meta?.name === 'Recorded sequence',
    },
    validate: (steps) => steps.length >= 2 || 'Record at least two chords.',
    onRecord: (value) => {
      setSequence(value)
      setSequenceProblem('')
      log(`Recorded sequence ${value.join(' → ')}`)
    },
    onReject: (reason) => setSequenceProblem(reason.message),
    onClear: () => {
      setSequence(['[KeyX]', '[KeyY]'])
      setSequenceProblem('Restored default sequence.')
    },
    onCancel: () => setSequenceProblem('Recording cancelled.'),
  })
  return (
    <section>
      <h2>Recording</h2>
      <p>
        Recorded bindings go directly into registrations. Changes live in this
        route's React state.
      </p>
      <label>
        Record by{' '}
        <select
          value={mode}
          disabled={recorder.isRecording || sequenceRecorder.isRecording}
          onChange={(e) => setMode(e.target.value as RecorderKeyMode)}
        >
          <option value="code">Physical code (default)</option>
          <option value="key">Logical character</option>
        </select>
      </label>
      <h3>Single shortcut</h3>
      <p>
        <kbd>{formatForDisplay(hotkey)}</kbd> — stored as <code>{hotkey}</code>
      </p>
      <button
        disabled={recorder.isRecording || sequenceRecorder.isRecording}
        onClick={() => {
          setProblem('')
          recorder.startRecording()
        }}
      >
        {recorder.isRecording ? 'Listening…' : 'Record shortcut'}
      </button>
      <button
        onClick={() => {
          recorder.stopRecording()
          setHotkey(initial)
          setProblem('')
        }}
      >
        Reset
      </button>
      {recorder.isRecording && (
        <button onClick={recorder.cancelRecording}>Cancel</button>
      )}
      <p>
        Include a modifier. Try Alt + 1 for a navigation conflict. Escape
        cancels; Backspace restores the initial shortcut.
      </p>
      <p role="status">{problem}</p>
      <h3>Sequence</h3>
      <p>
        {(sequenceRecorder.isRecording ? sequenceRecorder.steps : sequence)
          .map((step) => formatForDisplay(step))
          .join(' → ') || 'Waiting for the first chord…'}
      </p>
      <label>
        <input
          type="checkbox"
          checked={idle}
          onChange={(e) => setIdle(e.target.checked)}
        />{' '}
        Commit after 1.5 seconds idle
      </label>
      <label>
        <input
          type="checkbox"
          checked={commitOnEnter}
          onChange={(e) => setCommitOnEnter(e.target.checked)}
        />{' '}
        Enter commits the sequence
      </label>
      <p>
        <button
          disabled={recorder.isRecording || sequenceRecorder.isRecording}
          onClick={() => {
            setSequenceProblem('')
            sequenceRecorder.startRecording()
          }}
        >
          Record sequence
        </button>
        <button
          disabled={
            !sequenceRecorder.isRecording || !sequenceRecorder.steps.length
          }
          onClick={sequenceRecorder.commitRecording}
        >
          Commit
        </button>
        {sequenceRecorder.isRecording && (
          <button onClick={sequenceRecorder.cancelRecording}>Cancel</button>
        )}
      </p>
      <p>
        Record at least two chords. Backspace removes a step; when empty it
        restores the initial sequence. Rejected steps remain editable.
      </p>
      <p role="status">{sequenceProblem}</p>
    </section>
  )
}

/** Formatting changes labels, not the binding being registered. */
function Formatting() {
  const [platform, setPlatform] = useState<'mac' | 'windows' | 'linux'>('mac')
  const [modifierSymbols, setModifierSymbols] = useState(false)
  const [keySymbols, setKeySymbols] = useState(true)
  const options = {
    platform,
    useSymbols: { modifiers: modifierSymbols, keys: keySymbols },
  }
  return (
    <section>
      <h2>Formatting</h2>
      <label>
        Platform{' '}
        <select
          value={platform}
          onChange={(e) => setPlatform(e.target.value as typeof platform)}
        >
          <option value="mac">macOS</option>
          <option value="windows">Windows</option>
          <option value="linux">Linux</option>
        </select>
      </label>
      <label>
        <input
          type="checkbox"
          checked={modifierSymbols}
          onChange={(e) => setModifierSymbols(e.target.checked)}
        />{' '}
        Modifier symbols
      </label>
      <label>
        <input
          type="checkbox"
          checked={keySymbols}
          onChange={(e) => setKeySymbols(e.target.checked)}
        />{' '}
        Key symbols
      </label>
      <table>
        <thead>
          <tr>
            <th>Stored binding</th>
            <th>String</th>
            <th>Parts</th>
          </tr>
        </thead>
        <tbody>
          {(
            [
              'Mod+Shift+ArrowUp',
              'Control++',
              'Alt+[KeyS]',
              'Mod+[NumpadAdd]',
            ] as const
          ).map((hotkey) => (
            <tr key={hotkey}>
              <td>
                <code>{hotkey}</code>
              </td>
              <td>{formatForDisplay(hotkey, options)}</td>
              <td>
                {formatForDisplay(hotkey, { ...options, parts: true }).map(
                  (part, i) => (
                    <kbd key={i}>{part}</kbd>
                  ),
                )}
              </td>
            </tr>
          ))}
        </tbody>
      </table>
      <p>
        Physical codes use readable fallback labels. Supply a resolved{' '}
        <code>layoutMap</code> or explicit <code>keyLabels</code> for
        layout-specific labels.
      </p>
    </section>
  )
}

const rootRoute = createRootRoute({ component: Layout })
const routeTree = rootRoute.addChildren([
  createRoute({
    getParentRoute: () => rootRoute,
    path: '/',
    component: Tickets,
  }),
  createRoute({
    getParentRoute: () => rootRoute,
    path: '/editor',
    component: Editor,
  }),
  createRoute({
    getParentRoute: () => rootRoute,
    path: '/sequences',
    component: Sequences,
  }),
  createRoute({
    getParentRoute: () => rootRoute,
    path: '/recording',
    component: Recording,
  }),
  createRoute({
    getParentRoute: () => rootRoute,
    path: '/formatting',
    component: Formatting,
  }),
])
const router = createRouter({ routeTree })
declare module '@tanstack/react-router' {
  interface Register {
    router: typeof router
  }
}

const root = createRoot(document.getElementById('root')!)
root.render(
  <HotkeysProvider defaultOptions={{ hotkey: { requireReset: true } }}>
    <RouterProvider router={router} />
  </HotkeysProvider>,
)

// Clean up registrations when this entry module is replaced during development.
import.meta.hot?.dispose(() => root.unmount())

TanStack

Svelte Example: Kitchen Sink

<script lang="ts">
  import { onMount, setContext } from 'svelte'
  import {
    createHotkeys,
    createHotkey,
    formatForDisplay,
    getHeldKeys,
    getHeldKeyCodesMap,
    getIsKeyHeld,
    getHotkeyRegistrations,
  } from '@tanstack/svelte-hotkeys'
  import Tickets from './Tickets.svelte'
  import Editor from './Editor.svelte'
  import Sequences from './Sequences.svelte'
  import Recording from './Recording.svelte'
  import Formatting from './Formatting.svelte'
  import Hint from './Hint.svelte'
  const pages = [
    { path: '/', name: 'Tickets', component: Tickets, hotkey: 'Alt+[Digit1]' },
    {
      path: '/editor',
      name: 'Editor',
      component: Editor,
      hotkey: 'Alt+[Digit2]',
    },
    {
      path: '/sequences',
      name: 'Sequences',
      component: Sequences,
      hotkey: 'Alt+[Digit3]',
    },
    {
      path: '/recording',
      name: 'Recording',
      component: Recording,
      hotkey: 'Alt+[Digit4]',
    },
    {
      path: '/formatting',
      name: 'Formatting',
      component: Formatting,
      hotkey: 'Alt+[Digit5]',
    },
  ] as const
  let path = $state(location.hash.slice(1) || '/'),
    show = $state(false),
    activity = $state<Array<string>>([])
  onMount(() => {
    const update = () => {
      path = location.hash.slice(1) || '/'
    }
    window.addEventListener('hashchange', update)
    return () => window.removeEventListener('hashchange', update)
  })
  const page = $derived(pages.find((p) => p.path === path) ?? pages[0])
  setContext('log', (message: string) => {
    activity = [message, ...activity].slice(0, 6)
  })
  const keys = getHeldKeys(),
    codes = getHeldKeyCodesMap(),
    shift = getIsKeyHeld('Shift'),
    registry = getHotkeyRegistrations()
  createHotkeys(
    pages.map((p) => ({
      hotkey: p.hotkey,
      callback: () => {
        location.hash = p.path
      },
      options: { meta: { name: p.name, group: 'Navigation' } },
    })),
    { ignoreInputs: true },
  )
  createHotkey(
    'Alt+Shift+[KeyK]',
    () => {
      show = !show
    },
    { meta: { name: 'Show shortcuts', group: 'Navigation' } },
  )
</script>

<header>
  <h1>TanStack Hotkeys kitchen sink</h1>
  <p>
    Hold Alt / Option for hints. Route changes mount and unmount registrations.
  </p>
  <nav>
    {#each pages as p}<a href={`#${p.path}`} class:active={path === p.path}
        >{p.name} <Hint hotkey={p.hotkey} /></a
      >{/each}
  </nav>
  <button onclick={() => (show = !show)}
    >{show ? 'Hide' : 'Show'} shortcuts</button
  >
</header>
{#if show}<section>
    <h2>Live registry</h2>
    <table>
      <thead
        ><tr><th>Group / action</th><th>Binding</th><th>Status</th></tr></thead
      ><tbody>
        {#each [...registry.hotkeys, ...registry.sequences] as reg (reg.id)}<tr
            ><td>{reg.options.meta?.group} / {reg.options.meta?.name}</td><td
              >{('hotkey' in reg ? [reg.hotkey] : reg.sequence)
                .map((h) => formatForDisplay(h))
                .join(' → ')}</td
            ><td
              >{reg.options.enabled === false
                ? 'Disabled'
                : `${reg.triggerCount} fired`}</td
            ></tr
          >{/each}</tbody
      >
    </table>
  </section>{/if}
<main>
  {#key page.path}<page.component />{/key}
</main>
<section>
  <h2>Key state</h2>
  <p>
    Keys: {keys.keys.join(' + ') || 'None'}<br />Codes: {Object.values(
      codes.codes,
    ).join(' + ') || 'None'}<br />Shift: {shift.held ? 'held' : 'released'}
  </p>
  <h2>Activity</h2>
  <button onclick={() => (activity = [])}>Clear log</button>
  <ul aria-live="polite">
    {#each activity as message}<li>{message}</li>{/each}
  </ul>
</section>